''''''''''''''''''''''''''''''''''''
' Screen 13h BSAVE Graphics Editor '
' (C) Copywrite Graham Downey 2015 '
'                                  '
''''''''''''''''''''''''''''''''''''
'$INCLUDE: 'qbx.bi'
REM '$DYNAMIC
CONST MajVer = 1
CONST MinVer = 1
DECLARE FUNCTION iMultikey% (iKey%)
DECLARE FUNCTION LoadGFX% ()
DECLARE FUNCTION BadFilename% (Filename$)
DECLARE FUNCTION FileExists% (FileSpec$)
DECLARE SUB ClearKBBuffer ()
DECLARE SUB InitKeyboard ()
DECLARE SUB MoveCursor (Direction$)
DECLARE SUB UpdateCursor (y%)
DECLARE SUB HelpScreen ()
DECLARE SUB DrawGUI ()
DECLARE SUB DrawGFX ()
DECLARE SUB GetGFX ()
DECLARE SUB NewGFX ()
DECLARE SUB SaveGFX ()
DECLARE SUB FloodFill ()
DECLARE SUB Recolor (OldColor%, NewColor%)
DECLARE SUB SetColor ()
DIM SHARED CurColor AS INTEGER
DIM SHARED Cursor AS INTEGER
DIM SHARED CurX AS INTEGER
DIM SHARED CurY AS INTEGER
DIM SHARED MinX AS INTEGER
DIM SHARED MinY AS INTEGER
DIM SHARED Pixel AS INTEGER
DIM SHARED Filename AS STRING ' * 12
DIM SHARED GFXHeight AS INTEGER
DIM SHARED GFXWidth AS INTEGER
DIM SHARED GFXSize AS INTEGER
DIM SHARED ScaleFactor AS INTEGER
DIM SHARED OldTime AS SINGLE
DEFINT A-Z
DEF SEG = &HA000

InitKeyboard
SCREEN 13
ScaleFactor = 4
StartScreen
NewGFX
REDIM SHARED GFX(GFXSize \ 2) AS INTEGER
GetGFX
DrawGUI
CurColor = 15
DO
	IF iMultikey(72) THEN MoveCursor ("U") 'Up arrow
	IF iMultikey(80) THEN MoveCursor ("D") 'Down arrow
	IF iMultikey(75) THEN MoveCursor ("L") 'Left arrow
	IF iMultikey(77) THEN MoveCursor ("R") 'Right arrow
	IF iMultikey(46) THEN SetColor         'The "C" key
	IF iMultikey(31) THEN SaveGFX          'The "S" key
	IF iMultikey(&H3B) THEN HelpScreen     'The "F1" key
	IF iMultikey(&H21) THEN FloodFill      'The "F" key
	IF iMultikey(&H13) THEN Recolor Pixel, CurColor 'The "R" key
	IF iMultikey(57) THEN                  'The space bar
		Pixel = CurColor
		POKE ((CurX + INT(32 - GFXWidth \ 2)) + ((CurY + INT(32 - GFXHeight \ 2)) * 320&)), Pixel
	END IF
	IF iMultikey(49) THEN                  'The "N" key
		NewGFX
		REDIM SHARED GFX(GFXSize \ 2) AS INTEGER
		CurX = 0: CurY = 0
		GetGFX
		DrawGUI
	END IF
	IF iMultikey(&H19) THEN                'The "P" key
		CCurY = INT(CurColor \ 16): CCurX = CurColor - (CCurY * 16)
		LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), &H19, B
		CurColor = Pixel
		CCurY = INT(CurColor \ 16): CCurX = CurColor - (CCurY * 16)
		LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), 15, B
	END IF
	IF iMultikey(&HD) THEN                 'The "+" key
		IF ScaleFactor < 4 THEN
			GetGFX
			ScaleFactor = ScaleFactor + 1
			MinX = INT(160 - GFXWidth * ScaleFactor \ 2) + 32
			MinY = INT(100 - GFXHeight * ScaleFactor \ 2)
			DrawGFX
		END IF
	END IF
	IF iMultikey(&HC) THEN                 'The "-" key
		IF ScaleFactor > 1 THEN
			GetGFX
			LINE (MinX, MinY)-STEP(GFXWidth * ScaleFactor - 1, GFXHeight * ScaleFactor - 1), 0, BF
			ScaleFactor = ScaleFactor - 1
			MinX = INT(160 - GFXWidth * ScaleFactor \ 2) + 32
			MinY = INT(100 - GFXHeight * ScaleFactor \ 2)
			DrawGFX
		END IF
	END IF
	IF iMultikey(24) THEN                  'The "O" key
		GetGFX
		'QB sux and won't let you REDIM in a sub
		IF LoadGFX THEN
			REDIM SHARED GFX(GFXSize \ 2) AS INTEGER
			DEF SEG = VARSEG(GFX(0))
			BLOAD Filename, VARPTR(GFX(0))
			DEF SEG = &HA000
		END IF
		CurX = 0: CurY = 0
		DrawGUI
	END IF
	IF iMultikey(16) OR iMultikey(1) THEN  'The "Q" and "Esc" key
		LOCATE 2, 10: PRINT "Really quit? (Y/N)>"
		DO
			KeyHit$ = UCASE$(INKEY$)
			IF KeyHit$ = "Y" OR KeyHit$ = "N" THEN
				Quit$ = KeyHit$: LOCATE 2, 29: PRINT Quit$;
			ELSEIF KeyHit$ = CHR$(13) THEN
				IF Quit$ = "Y" THEN END
				IF Quit$ = "N" THEN EXIT DO
			END IF
		LOOP
		DrawGUI
	END IF

	'Check if we need to blink the cursor
	IF ABS(OldTime - TIMER) > 1 / 4 THEN
		OldTime = TIMER
		UpdateCursor (1)
	END IF

	'Wait for 6 screen refreshes before looping
	WAIT &H3DA, 8: WAIT &H3DA, 8, 8
	WAIT &H3DA, 8: WAIT &H3DA, 8, 8
	WAIT &H3DA, 8: WAIT &H3DA, 8, 8
	WAIT &H3DA, 8: WAIT &H3DA, 8, 8
	WAIT &H3DA, 8: WAIT &H3DA, 8, 8
	WAIT &H3DA, 8: WAIT &H3DA, 8, 8
LOOP

FUNCTION BadFilename (Filename$)
	IF LEN(Filename) < 1 THEN
		BadFilename = 1
	ELSEIF INSTR(Filename, "/") THEN
		BadFilename = 1
	ELSEIF INSTR(Filename, ":") THEN
		BadFilename = 1
	ELSEIF INSTR(Filename, "?") THEN
		BadFilename = 1
	ELSEIF INSTR(Filename, "<") THEN
		BadFilename = 1
	ELSEIF INSTR(Filename, ">") THEN
		BadFilename = 1
	ELSEIF INSTR(Filename, "*") THEN
		BadFilename = 1
	ELSEIF INSTR(Filename, "|") THEN
		BadFilename = 1
	ELSE
		BadFilename = 0
	END IF
END FUNCTION

DEFSNG A-Z
SUB ClearKBBuffer
	DEF SEG = &H40
	POKE &H1A, PEEK(&H1C)
END SUB

DEFINT A-Z
SUB DrawGFX
	'Draws the small corner GFX
	StartX = INT(32 - GFXWidth \ 2)
	StartY = INT(32 - GFXHeight \ 2)
	PUT (StartX, StartY), GFX, PSET
	DEF SEG = &HA000
	Pixel = PEEK((StartX + CurX) + ((StartY + CurY) * 320&))

	'Draw the main GFX
	x = 0: y = 0
	DEF SEG = VARSEG(GFX(0))
	FOR e = 0 TO GFXWidth * GFXHeight - 1
		Byte = PEEK(VARPTR(GFX(0)) + 4 + e)
		LINE (MinX + x * ScaleFactor, MinY + y * ScaleFactor)-STEP(ScaleFactor - 1, ScaleFactor - 1), Byte, BF
		x = x + 1
		IF x = GFXWidth THEN
			x = 0
			y = y + 1
		END IF
	NEXT e
END SUB

SUB DrawGUI
	CLS
	'Left side bar
	LINE (0, 0)-(67, 200), &H19, BF
	'Editor Border
	LINE (65, 0)-(319, 199), &H19, B
	LINE (65, 1)-(318, 198), &H18, B
	LINE (66, 2)-(317, 197), &H17, B
	LINE (67, 3)-(316, 196), &H16, B

	'Color selector
	x = 1
	y = 64
	FOR c = 0 TO 255
		LINE (x, y)-STEP(2, 2), c, BF
		x = x + 4
		IF x = 65 THEN
			y = y + 4
			x = 1
		END IF
	NEXT c
	TmpMinX = INT(32 - GFXWidth \ 2)
	TmpMinY = INT(32 - GFXHeight \ 2)
	LINE (TmpMinX - 1, TmpMinY - 1)-STEP(GFXWidth + 1, GFXHeight + 1), &H18, B

	'Version
	LINE (11, 171)-(52, 188), &H18, B
	LINE (12, 172)-(51, 187), &H17, B
	LINE (13, 173)-(50, 186), &H16, B
	LINE (14, 174)-(49, 185), 16, BF
	COLOR &H19
	LOCATE 23, 3: PRINT "V" + LTRIM$(STR$(MajVer)) + "." + LTRIM$(STR$(MinVer));
	DrawGFX
END SUB

DEFSNG A-Z
FUNCTION FileExists% (FileSpec$)
	DIM InRegs AS RegTypeX, OutRegs AS RegTypeX
	'Convert file name to ASCIZ format
	ASCIZfile$ = FileSpec$ + CHR$(0)

	InRegs.ds = SSEG(ASCIZfile$)
	InRegs.dx = SADD(ASCIZfile$)
	InRegs.cx = 15 'any file attribute
	InRegs.ax = &H4E00

	CALL InterruptX(&H21, InRegs, OutRegs)
	IF OutRegs.flags AND 1 THEN
		FileExists = 0
	ELSE
		FileExists = 1
	END IF
END FUNCTION

DEFINT A-Z
SUB FloodFill
  IF Pixel = CurColor THEN EXIT SUB
  GetGFX
  CONST stksize = 256
  DIM scrwid AS INTEGER: scrwid = GFXWidth
  DIM scrhei AS INTEGER: scrhei = GFXHeight + 1
  DIM x AS INTEGER: x = CurX
  DIM y AS INTEGER: y = CurY
  DIM c AS INTEGER: c = CurColor

  DIM stk(0 TO stksize - 1) AS INTEGER

  DIM stkpos AS INTEGER
  stkpos = stksize

  DEF SEG = VARSEG(GFX(0))
  DIM screenp AS LONG, p AS LONG
  DIM x1 AS INTEGER, xx AS INTEGER
  DIM onlineA AS INTEGER, onlineB  AS INTEGER
  DIM oldx AS INTEGER, ya AS INTEGER, yb AS INTEGER
  DIM yagood AS INTEGER, ybgood AS INTEGER

  screenp = VARPTR(GFX(0)) + 4 'offset
  DIM fc AS INTEGER
  fc = PEEK((y * CLNG(scrwid)) + x + screenp)
  
  stkpos = stkpos - 2
  stk(stkpos + 0) = x
  stk(stkpos + 1) = y
  
  WHILE stkpos < stksize
	 x = stk(stkpos + 0)
	 y = stk(stkpos + 1)
	 stkpos = stkpos + 2
	 
	 p = screenp + y * CLNG(scrwid)
	 onlineA = 0: onlineB = 0
	 
	 DO
		x = x - 1
		IF x < 0 THEN EXIT DO
	 LOOP UNTIL PEEK(p + x) <> fc
	 x = x + 1
	 
	 oldx = x
	 ya = y - 1: yb = y + 1
	 yagood = (ya < scrhei) AND (ya >= 0)
	 ybgood = (yb < scrhei) AND (yb >= 0)
	 
	 IF ybgood THEN
		DO WHILE x < scrwid
	IF PEEK(p + x) <> fc THEN EXIT DO
	IF PEEK(p + x + scrwid) = fc THEN
	  IF onlineB = 0 THEN
		 stkpos = stkpos - 2
		 stk(stkpos + 0) = x
		 stk(stkpos + 1) = yb
		 onlineB = 1
	  END IF
	ELSE
	  onlineB = 0
	END IF
	x = x + 1
		LOOP
	 END IF
	 IF yagood THEN
		FOR xx = oldx TO x - 1
	IF PEEK(p + xx - scrwid) = fc THEN
	  IF onlineA = 0 THEN
		 stkpos = stkpos - 2
		 stk(stkpos + 0) = xx
		 stk(stkpos + 1) = ya
		 onlineA = 1
	  END IF
	ELSE
	  onlineA = 0
	END IF
		NEXT xx
	 END IF
	 
	 FOR x1 = oldx TO x - 1
		POKE p + x1, c
	 NEXT x1

  WEND
  DrawGFX
END SUB

SUB GetGFX
	StartX = INT(32 - GFXWidth \ 2)
	StartY = INT(32 - GFXHeight \ 2)
	'POKE ((CurX + 32) + ((CurY + 32) * 320&)), Pixel
	GET (StartX, StartY)-STEP(GFXWidth - 1, GFXHeight - 1), GFX(0)
END SUB

SUB HelpScreen
	GetGFX
	CLS
	SCREEN 0
	WIDTH 80, 25
	COLOR 7'&H19
	PRINT : PRINT
	LOCATE CSRLIN, 21: PRINT "Ŀ"
	LOCATE CSRLIN, 21: PRINT "                                      "
	LOCATE CSRLIN, 21: PRINT "             VGABSV Help              "
	LOCATE CSRLIN, 21: PRINT "                                      "
	LOCATE CSRLIN, 21: PRINT "͵"
	LOCATE CSRLIN, 21: PRINT "F1     This screen                   "
	LOCATE CSRLIN, 21: PRINT "                                     "
	LOCATE CSRLIN, 21: PRINT "+      Zoom in on graphic            "
	LOCATE CSRLIN, 21: PRINT "-      Zoom out of graphic           "
	LOCATE CSRLIN, 21: PRINT "                                     "
	LOCATE CSRLIN, 21: PRINT "N      Create new graphic            "
	LOCATE CSRLIN, 21: PRINT "S      Save graphic to disk          "
	LOCATE CSRLIN, 21: PRINT "O      Open existing graphic on disk "
	LOCATE CSRLIN, 21: PRINT "                                     "
	LOCATE CSRLIN, 21: PRINT "C      Change cursor color           "
	LOCATE CSRLIN, 21: PRINT "P      Pick color under cursor       "
	LOCATE CSRLIN, 21: PRINT "Space  Place a pixel at the cursor   "
	LOCATE CSRLIN, 21: PRINT "R      Recolor every occurence of a  "
	LOCATE CSRLIN, 21: PRINT "       color in your graphic         "
	LOCATE CSRLIN, 21: PRINT "F      Floodfill over a specific     "
	LOCATE CSRLIN, 21: PRINT "       color within borders of an    "
	LOCATE CSRLIN, 21: PRINT "       area in your graphic          "
	LOCATE CSRLIN, 21: PRINT "                                     "
	LOCATE CSRLIN, 21: PRINT "Esc/Q  Quit to DOS                   ";
	LOCATE CSRLIN + 1, 21: PRINT "";
	SLEEP
	SCREEN 13
	DrawGUI
END SUB

DEFSNG A-Z
FUNCTION iMultikey% (iKey%)
  DEF SEG = &HB000
  iKey2% = iKey% AND 255
  iMultikey% = ((PEEK(iKey2%) AND PEEK(iKey2% + 256)) = 0)
  'Sorry Mysoft... I put these here anyway :P
  ClearKBBuffer
  DEF SEG = &HA000
END FUNCTION

SUB InitKeyboard
  DIM lKeys(172) AS LONG, I AS INTEGER
  FOR I = 0 TO 127: lKeys(I) = &H80808080: NEXT I
  lKeys(128) = &H60EC8B55: lKeys(129) = &H8BFA061E: lKeys(130) = &H76C5066E
  lKeys(131) = &HB000B800: lKeys(132) = &HAFB9C08E: lKeys(133) = &HF3FF3302
  lKeys(134) = &H33D88EA4: lKeys(135) = &H3515B8F6: lKeys(136) = &HC08C21CD
  lKeys(137) = &HC23BDA8C: lKeys(138) = &H7507406A: lKeys(139) = &HA1266607
  lKeys(140) = &HBEB00B5: lKeys(141) = &H10E0C166: lKeys(142) = &H2666C38B
  lKeys(143) = &H6600B5A3: lKeys(144) = &H2908489: lKeys(145) = &H25C948D
  lKeys(146) = &HCD2515B8: lKeys(147) = &HCD62B421: lKeys(148) = &H1E892621
  lKeys(149) = &H7FB00B3: lKeys(150) = &HCB5D611F: lKeys(151) = &H4FFC809C
  lKeys(152) = &H1E602C75: lKeys(153) = &HB41F406A: lKeys(154) = &H3921CD62
  lKeys(155) = &HE800B31E: lKeys(156) = &H755B0000: lKeys(157) = &H3C00B426
  lKeys(158) = &H2E1974E0: lKeys(159) = &H447C6: lKeys(160) = &H8025D803
  lKeys(161) = &H2ED82B00: lKeys(162) = &HFD8E8788: lKeys(163) = &HEA9D611F
  lKeys(164) = &HFFFFFFFF: lKeys(165) = &H447C62E: lKeys(166) = &HC6F1EB01
  lKeys(167) = -&HFFFF4CFA: lKeys(168) = &H1E578B2E: lKeys(169) = &H205F8E2E
  lKeys(170) = &HCD2515B8: lKeys(171) = &HDDEB21

  DEF SEG = VARSEG(lKeys(0))
  CALL absolute(lKeys(), VARPTR(lKeys(0)) + 512)
END SUB

DEFINT A-Z
FUNCTION LoadGFX%
	DIM tmpByte AS STRING * 1
	DIM Temp AS INTEGER
	COLOR 7
	LOCATE 2, 10: INPUT "Filename>", Filename
	LOCATE 3, 10
	IF FileExists(Filename) THEN
		PRINT "Loading..."
	ELSE
		PRINT "File not found!"
		SLEEP
		EXIT FUNCTION
	END IF
	DIM F AS INTEGER: F = FREEFILE
	OPEN Filename FOR BINARY ACCESS READ AS F
	'Make sure it's a QB BSAVE file
	GET #F, , Temp    'magic
	IF Temp = CVI("BM") THEN
		PRINT "Windows BMP files not"
		LOCATE 5, 10: PRINT "supported"
		SLEEP: CLOSE F: EXIT FUNCTION
	ELSEIF (Temp AND &HFF) <> &HFD THEN
		PRINT "Only QB BSAVE graphics"
		LOCATE 5, 10: PRINT "supported"
		SLEEP: CLOSE F: EXIT FUNCTION
	END IF
	'Read in the dimensions of the graphic
	GET #F, 6, TmpSize
	GET #F, 10, TmpHeight
	GET #F, 8, TmpWidth     'GFXWidth is width * 8
	TmpWidth = TmpWidth \ 8
	'LOCATE 4, 10: PRINT "Width: " + STR$(TmpWidth) + "px"
	'LOCATE 5, 10: PRINT "Height:" + STR$(TmpHeight) + "px"
	'LOCATE 6, 10: PRINT "Size:  " + STR$(TmpSize) + " bytes"
	IF TmpWidth * TmpHeight <> TmpSize - 4 THEN
		LOCATE CSRLIN, 10
		PRINT "Not a screen 13h BSAVE file..."
		SLEEP: CLOSE F: EXIT FUNCTION
	END IF
	
	GFXSize = TmpSize
	GFXWidth = TmpWidth
	GFXHeight = TmpHeight
	MinX = INT(160 - GFXWidth * ScaleFactor \ 2) + 32
	MinY = INT(100 - GFXHeight * ScaleFactor \ 2)
	LoadGFX = 1
	CLOSE F
END FUNCTION

DEFSNG A-Z
SUB MoveCursor (Direction$)
	DIM x AS INTEGER, y AS INTEGER
	x = MinX + CurX * ScaleFactor
	y = MinY + CurY * ScaleFactor
	'Scaled image
	IF ScaleFactor > 1 THEN
		LINE (x, y)-(x + ScaleFactor - 1, y + ScaleFactor - 1), Pixel, BF
	ELSE
		POKE (x + (y * 320&)), Pixel
	END IF
	'Actual size image
	TmpMinX = INT(32 - GFXWidth \ 2)
	TmpMinY = INT(32 - GFXHeight \ 2)
	POKE (TmpMinX + CurX + ((TmpMinY + CurY) * 320&)), Pixel
	SELECT CASE Direction$
		CASE "U"
			IF CurY > 0 THEN
				CurY = CurY - 1
			END IF
		CASE "D"
			IF CurY < GFXHeight - 1 THEN
				CurY = CurY + 1
			END IF
		CASE "L"
			IF CurX > 0 THEN
				CurX = CurX - 1
			END IF
		CASE "R"
			IF CurX < GFXWidth - 1 THEN
				CurX = CurX + 1
			END IF
	END SELECT
	Pixel = PEEK(TmpMinX + CurX + ((TmpMinY + CurY) * 320&))
	UpdateCursor (0)
END SUB

SUB NewGFX
	CLS
	DIM SetBG AS STRING * 1
	DIM KeyHit AS STRING * 1
	DIM BGColor AS INTEGER
	COLOR 7
	DO
		LOCATE 1, 1: PRINT "GFX width>                              "
		LOCATE 1, 11: INPUT "", Inpt$
		TmpWidth! = VAL(Inpt$)
		IF TmpWidth > 0 AND TmpWidth <= 62 THEN
			EXIT DO
		ELSE
			LOCATE 2, 1: PRINT "Must be between 1 and 62"
		END IF
	LOOP
	DO
		LOCATE 2, 1: PRINT "GFX height>                             "
		LOCATE 2, 12: INPUT "", Inpt$
		TmpHeight! = VAL(Inpt$)
		IF TmpHeight > 0 AND TmpHeight <= 48 THEN
			EXIT DO
		ELSE
			LOCATE 3, 1: PRINT "Must be between 1 and 48"
		END IF
	LOOP
	GFXWidth = TmpWidth: GFXHeight = TmpHeight
	'Calculate values to center graphic in draw area
	MinX = INT(160 - GFXWidth * ScaleFactor \ 2) + 32
	MinY = INT(100 - GFXHeight * ScaleFactor \ 2)
	'Calculate graphic size in bytes
	GFXSize = GFXWidth * GFXHeight + 4
	DO
		LOCATE 3, 1: PRINT "Set background color? (Y/N)>"
		KeyHit = UCASE$(INKEY$)
		IF KeyHit = "Y" OR KeyHit = "N" THEN
			 SetBG = KeyHit: LOCATE 3, 29: PRINT SetBG
		ELSEIF KeyHit = CHR$(13) THEN
			IF SetBG = "Y" OR SetBG = "N" THEN EXIT DO
		END IF
	LOOP
	CLS
	'Draw hex color table
	IF SetBG = "Y" THEN
		FOR x = 0 TO 255
			IF POS(0) = 1 THEN LOCATE CSRLIN, 2
			COLOR x
			IF x < 16 THEN
				PRINT "0" + HEX$(x) + " ";
			ELSE
				PRINT HEX$(x) + " ";
			END IF
		NEXT x
		COLOR 7: LOCATE 24, 1
		INPUT "Enter new color>", HexColor$
		BGColor = VAL("&H" + HexColor$)
		CLS
		'Draw actual Size image
		TmpMinX = INT(32 - GFXWidth \ 2)
		TmpMinY = INT(32 - GFXHeight \ 2)
		LINE (TmpMinX, TmpMinY)-STEP(GFXWidth - 1, GFXHeight - 1), BGColor, BF
	END IF
	'Draw color selector cursor
	CCurY = INT(BGColor \ 16): CCurX = BGColor - (CCurY * 16)
	LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), BGColor, B
	DEF SEG = &HA000
	StartX = INT(32 - GFXWidth \ 2)
	StartY = INT(32 - GFXHeight \ 2)
	Pixel = PEEK(StartX + (StartY * 320&))
END SUB

DEFINT A-Z
SUB Recolor (OldColor%, NewColor%)
	GetGFX
	DEF SEG = VARSEG(GFX(0))
	OldPixel& = VARPTR(GFX(0)) + 4
	FOR e = 0 TO GFXWidth * GFXHeight - 1
		IF PEEK(OldPixel& + e) = OldColor% THEN
			POKE OldPixel& + e, NewColor%
		END IF
	NEXT e
	DEF SEG = &HA000
	DrawGFX
END SUB

DEFSNG A-Z
SUB SaveGFX
	DIM KeyHit AS STRING
	DIM OverWrite AS STRING
	GetGFX
	COLOR 7
	LOCATE 2, 10: INPUT "Filename>", Filename
	IF BadFilename(Filename) THEN
		LOCATE 3, 10: PRINT "Bad filename!"
		SLEEP: DrawGUI
		EXIT SUB
	END IF
	IF FileExists(Filename) THEN
		DO
			LOCATE 3, 10: PRINT "Overwrite " + Filename + "?";
			KeyHit = UCASE$(INKEY$)
			IF KeyHit = "Y" OR KeyHit = "N" THEN
				OverWrite = KeyHit: LOCATE 3, POS(0): PRINT OverWrite;
			ELSEIF KeyHit = CHR$(13) THEN
				IF OverWrite = "Y" OR OverWrite = "N" THEN EXIT DO
			END IF
		LOOP
		IF OverWrite = "N" THEN
			DrawGUI
			EXIT SUB
		END IF
	END IF
	DEF SEG = VARSEG(GFX(0))
	BSAVE Filename, VARPTR(GFX(0)), GFXSize
	DEF SEG = &HA000
	DrawGUI
END SUB

DEFINT A-Z
SUB SetColor
 CCurY = INT(CurColor \ 16)
 CCurX = CurColor - (CCurY * 16)
 DO
	IF iMultikey(72) THEN   'Up arrow
		LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), &H19, B
		IF CCurY >= 1 THEN CCurY = CCurY - 1
	END IF
	IF iMultikey(80) THEN   'Down arrow
		LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), &H19, B
		IF CCurY < 15 THEN CCurY = CCurY + 1
	END IF
	IF iMultikey(75) THEN   'Left arrow
		LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), &H19, B
		IF CCurX >= 1 THEN CCurX = CCurX - 1
	END IF
	IF iMultikey(77) THEN   'Right arrow
		LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), &H19, B
		IF CCurX < 15 THEN CCurX = CCurX + 1
	END IF
	IF iMultikey(&H1C) OR iMultikey(57) THEN 'Return or space key
		'LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), &H19, B
		CurColor = CCurX + (CCurY * 16)
		EXIT SUB
	END IF
	LINE (CCurX * 4, CCurY * 4 + 63)-STEP(4, 4), 15, B
	SLEEP
 LOOP
END SUB

SUB UpdateCursor (U%)
	IF U% THEN
		IF Cursor = 0 AND Cursor <> Pixel OR Cursor = 15 AND Cursor <> Pixel THEN
			Cursor = Pixel
		ELSE
			IF Pixel > 103 OR Pixel > 15 AND Pixel < 27 OR Pixel < 2 THEN
				Cursor = 15
			ELSE
				Cursor = 0
			END IF
		END IF
	ELSE
		IF Pixel > 103 OR Pixel > 15 AND Pixel < 27 OR Pixel < 2 THEN
			Cursor = 15
		ELSE
			Cursor = 0
		END IF
		OldTime = TIMER
	END IF

	x = MinX + CurX * ScaleFactor
	y = MinY + CurY * ScaleFactor
	IF ScaleFactor > 1 THEN
		LINE (x, y)-(x + ScaleFactor - 1, y + ScaleFactor - 1), Cursor, BF
	ELSE
		POKE (x + (y * 320&)), Cursor
	END IF
END SUB

